import direct.directbase.DirectStart
from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import *
from direct.interval.IntervalGlobal import *

import math
import sys
import random

class Personagem():
	def __init__(self):
		self.ultimoMov = 'n'
		self.node = None
		self.velocidade = 0.45
		
	def moveParaCima(self):
   		self.y = self.node.getY() + self.velocidade
		self.node.setY(self.y)
		self.rotaParaCima()

	def rotaParaCima(self):
		self.ultimoMov = 'c'
		self.node.setH(90)

	def moveParaBaixo(self):
   		self.y = self.node.getY() - self.velocidade
		self.node.setY(self.y)
		self.rotaParaBaixo()

	def rotaParaBaixo(self):
		self.ultimoMov = 'b'
		self.node.setH(-90)

	def moveParaLadoDireito(self):
		self.x = self.node.getX() + self.velocidade
		self.node.setX(self.x)
		self.rotaParaDireita()		

	def rotaParaDireita(self):
		self.ultimoMov = 'd'
		self.node.setH(0)

	def moveParaLadoEsquerdo(self):
		self.x = self.node.getX() - self.velocidade
		self.node.setX(self.x)
		self.rotaParaEsquerda()		

	def rotaParaEsquerda(self):
		self.ultimoMov = 'e'
		self.node.setH(-180)
	
	def volta(self):
		if self.ultimoMov == 'd':
			self.x = self.node.getX() - self.velocidade
			self.node.setX(self.x)
		elif self.ultimoMov == 'e':
			self.x = self.node.getX() + self.velocidade
			self.node.setX(self.x)
		elif self.ultimoMov == 'c':
			self.y = self.node.getY() - self.velocidade
			self.node.setY(self.y)
		else:
			self.y = self.node.getY() + self.velocidade
			self.node.setY(self.y)

	def andaPerpendicular(self):
		numEscolhido = random.randrange(1,3)
		if self.ultimoMov == 'd' or self.ultimoMov == 'e':	
			if numEscolhido == 1:
				self.moveParaCima()		
			else:
				self.moveParaBaixo()
		else:
			if numEscolhido == 1:
				self.moveParaLadoEsquerdo()		
			elif numEscolhido == 2:
				self.moveParaLadoDireito()

	def andaDirecaoContraria(self):
		if self.ultimoMov == 'd':
			self.moveParaLadoEsquerdo()
		elif self.ultimoMov == 'e':
			self.moveParaLadoDireito()
		elif self.ultimoMov == 'c':
			self.moveParaBaixo()
		else:
			self.moveParaCima()

	def andaNaMesmaDirecao(self):
		if self.ultimoMov == 'e':
			self.moveParaLadoEsquerdo()
		elif self.ultimoMov == 'd':
			self.moveParaLadoDireito()
		elif self.ultimoMov == 'b':
			self.moveParaBaixo()
		else:
			self.moveParaCima()


	def rota(self):
		if self.ultimoMov == 'b':
			self.rotaParaEsquerda()
		elif self.ultimoMov == 'c':
			self.rotaParaDireita()
		elif self.ultimoMov == 'd':
			self.rotaParaBaixo()
		else:
			self.rotaParaBaixo()
